# coding: utf-8
"""
    Cortex Analyst API.

    The Snowflake Cortex Analyst API is a REST API that allows end user to chat with their data leveraging semantic models to generate SQL queries.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@snowflake.com
    Generated by: https://openapi-generator.tech

    Do not edit this file manually.
"""

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from typing import Union

from snowflake.core.cortex_analyst._generated.models.table_columns import TableColumns

from snowflake.core.cortex_analyst._generated.models.warning import Warning

from pydantic import BaseModel, ConfigDict, StrictStr

from typing import Any, ClassVar, Dict, List, Optional


class PreSelectionResponse(BaseModel):
    """A model object representing the PreSelectionResponse resource.

    Constructs an object of type PreSelectionResponse with the provided properties.

    Parameters
    __________
    request_id : str, optional
        Unique request ID
    tables : List[TableColumns], optional

    warnings : List[Warning], optional
    """

    request_id: Optional[StrictStr] = None

    tables: Optional[List[TableColumns]] = None

    warnings: Optional[List[Warning]] = None

    __properties = ["request_id", "tables", "warnings"]

    class Config:
        populate_by_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias."""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias."""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PreSelectionResponse:
        """Create an instance of PreSelectionResponse from a JSON string."""
        return cls.from_dict(json.loads(json_str))

    def to_dict(
        self,
        hide_readonly_properties: bool = False,
    ) -> dict[str, Any]:
        """Returns the dictionary representation of the model using alias."""

        exclude_properties = set()

        if hide_readonly_properties:
            exclude_properties.update({})

        _dict = dict(
            self._iter(to_dict=True,
                       by_alias=True,
                       exclude=exclude_properties,
                       exclude_none=True))

        # override the default output from pydantic by calling `to_dict()` of each item in tables (list)
        _items = []
        if self.tables:
            for _item in self.tables:
                if _item:
                    _items.append(_item.to_dict())
            _dict['tables'] = _items

        # override the default output from pydantic by calling `to_dict()` of each item in warnings (list)
        _items = []
        if self.warnings:
            for _item in self.warnings:
                if _item:
                    _items.append(_item.to_dict())
            _dict['warnings'] = _items

        return _dict

    def to_dict_without_readonly_properties(self) -> dict[str, Any]:
        """Return the dictionary representation of the model without readonly properties."""
        return self.to_dict(hide_readonly_properties=True)

    @classmethod
    def from_dict(cls, obj: dict) -> PreSelectionResponse:
        """Create an instance of PreSelectionResponse from a dict."""

        if obj is None:
            return None

        if type(obj) is not dict:
            return PreSelectionResponse.parse_obj(obj)

        _obj = PreSelectionResponse.parse_obj({
            "request_id":
            obj.get("request_id"),
            "tables":
            [TableColumns.from_dict(_item) for _item in obj.get("tables")]
            if obj.get("tables") is not None else None,
            "warnings":
            [Warning.from_dict(_item) for _item in obj.get("warnings")]
            if obj.get("warnings") is not None else None,
        })

        return _obj


from typing import Optional, List, Dict

from snowflake.core.cortex_analyst._generated.models.table_columns import TableColumns

from snowflake.core.cortex_analyst._generated.models.warning import Warning


class PreSelectionResponseModel():

    def __init__(
        self,  # optional properties
        request_id: Optional[str] = None,
        tables: Optional[List[TableColumns]] = None,
        warnings: Optional[List[Warning]] = None,
    ):
        """A model object representing the PreSelectionResponse resource.

        Constructs an object of type PreSelectionResponse with the provided properties.

        Parameters
        __________
        request_id : str, optional
            Unique request ID
        tables : List[TableColumns], optional

        warnings : List[Warning], optional
        """

        self.request_id = request_id
        self.tables = tables
        self.warnings = warnings

    __properties = ["request_id", "tables", "warnings"]

    def __repr__(self) -> str:
        return repr(self._to_model())

    def _to_model(self):
        return PreSelectionResponse(
            request_id=self.request_id,
            tables=[x._to_model()
                    for x in self.tables] if self.tables is not None else None,
            warnings=[x._to_model() for x in self.warnings]
            if self.warnings is not None else None,
        )

    @classmethod
    def _from_model(cls, model) -> PreSelectionResponseModel:
        return PreSelectionResponseModel(
            request_id=model.request_id,
            tables=[TableColumnsModel._from_model(x) for x in model.tables]
            if model.tables is not None else None,
            warnings=[WarningModel._from_model(x) for x in model.warnings]
            if model.warnings is not None else None,
        )

    def to_dict(self):
        """Creates a dictionary of the properties from a PreSelectionResponse.

        This method constructs a dictionary with the key-value entries corresponding to the properties of the PreSelectionResponse object.

        Returns
        _______
        dict
            A dictionary object created using the input model.
        """
        return self._to_model().to_dict()

    @classmethod
    def from_dict(cls, obj: dict) -> PreSelectionResponseModel:
        """Creates an instance of PreSelectionResponse from a dict.

        This method constructs a PreSelectionResponse object from a dictionary with the key-value pairs of its properties.

        Parameters
        ----------
        obj : dict
            A dictionary whose keys and values correspond to the properties of the resource object.

        Returns
        _______
        PreSelectionResponse
            A PreSelectionResponse object created using the input dictionary; this will fail if the required properties are missing.
        """
        return cls._from_model(PreSelectionResponse.from_dict(obj))


PreSelectionResponse._model_class = PreSelectionResponseModel
