# coding: utf-8
"""
    Cortex Analyst API.

    The Snowflake Cortex Analyst API is a REST API that allows end user to chat with their data leveraging semantic models to generate SQL queries.  # noqa: E501

    The version of the OpenAPI document: 0.0.1
    Contact: support@snowflake.com
    Generated by: https://openapi-generator.tech

    Do not edit this file manually.
"""

from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from typing import Union

from snowflake.core.cortex_analyst._generated.models.annotated_sql_query import AnnotatedSqlQuery

from pydantic import BaseModel, ConfigDict

from typing import Any, ClassVar, Dict, List


class SqlInputs(BaseModel):
    """A model object representing the SqlInputs resource.

    Constructs an object of type SqlInputs with the provided properties.

    Parameters
    __________
    queries : List[AnnotatedSqlQuery]
    """

    queries: List[AnnotatedSqlQuery]

    __properties = ["queries"]

    class Config:
        populate_by_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias."""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias."""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> SqlInputs:
        """Create an instance of SqlInputs from a JSON string."""
        return cls.from_dict(json.loads(json_str))

    def to_dict(
        self,
        hide_readonly_properties: bool = False,
    ) -> dict[str, Any]:
        """Returns the dictionary representation of the model using alias."""

        exclude_properties = set()

        if hide_readonly_properties:
            exclude_properties.update({})

        _dict = dict(
            self._iter(to_dict=True,
                       by_alias=True,
                       exclude=exclude_properties,
                       exclude_none=True))

        # override the default output from pydantic by calling `to_dict()` of each item in queries (list)
        _items = []
        if self.queries:
            for _item in self.queries:
                if _item:
                    _items.append(_item.to_dict())
            _dict['queries'] = _items

        return _dict

    def to_dict_without_readonly_properties(self) -> dict[str, Any]:
        """Return the dictionary representation of the model without readonly properties."""
        return self.to_dict(hide_readonly_properties=True)

    @classmethod
    def from_dict(cls, obj: dict) -> SqlInputs:
        """Create an instance of SqlInputs from a dict."""

        if obj is None:
            return None

        if type(obj) is not dict:
            return SqlInputs.parse_obj(obj)

        _obj = SqlInputs.parse_obj({
            "queries": [
                AnnotatedSqlQuery.from_dict(_item)
                for _item in obj.get("queries")
            ] if obj.get("queries") is not None else None,
        })

        return _obj


from typing import Optional, List, Dict

from snowflake.core.cortex_analyst._generated.models.annotated_sql_query import AnnotatedSqlQuery


class SqlInputsModel():

    def __init__(
        self,
        queries: List[AnnotatedSqlQuery],
        # optional properties
    ):
        """A model object representing the SqlInputs resource.

        Constructs an object of type SqlInputs with the provided properties.

        Parameters
        __________
        queries : List[AnnotatedSqlQuery]
        """

        self.queries = queries

    __properties = ["queries"]

    def __repr__(self) -> str:
        return repr(self._to_model())

    def _to_model(self):
        return SqlInputs(queries=[x._to_model() for x in self.queries]
                         if self.queries is not None else None, )

    @classmethod
    def _from_model(cls, model) -> SqlInputsModel:
        return SqlInputsModel(queries=[
            AnnotatedSqlQueryModel._from_model(x) for x in model.queries
        ] if model.queries is not None else None, )

    def to_dict(self):
        """Creates a dictionary of the properties from a SqlInputs.

        This method constructs a dictionary with the key-value entries corresponding to the properties of the SqlInputs object.

        Returns
        _______
        dict
            A dictionary object created using the input model.
        """
        return self._to_model().to_dict()

    @classmethod
    def from_dict(cls, obj: dict) -> SqlInputsModel:
        """Creates an instance of SqlInputs from a dict.

        This method constructs a SqlInputs object from a dictionary with the key-value pairs of its properties.

        Parameters
        ----------
        obj : dict
            A dictionary whose keys and values correspond to the properties of the resource object.

        Returns
        _______
        SqlInputs
            A SqlInputs object created using the input dictionary; this will fail if the required properties are missing.
        """
        return cls._from_model(SqlInputs.from_dict(obj))


SqlInputs._model_class = SqlInputsModel
